# Generated by Django 2.2.28 on 2023-05-25 13:51

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields
import djangoldp_needle.permissions.needle_user_contact_pending


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('djangoldp_needle', '0034_auto_20230515_1735'),
    ]

    operations = [
        migrations.CreateModel(
            name='NeedleUserContactPending',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('contact_to_email', models.CharField(max_length=255)),
                ('contact_from', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='contact_pending_from', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
                'default_permissions': ['add', 'change', 'delete', 'view', 'control'],
                'rdf_type': 'hd:needle_user_contact_pending',
                'auto_author': 'contact_from',
                'owner_field': 'contact_from',
                'permission_classes': [djangoldp_needle.permissions.needle_user_contact_pending.NeedleUserContactPendingPermissions],
                'serializer_fields': ['@id', 'creation_date', 'contact_from', 'contact_to_email'],
                'depth': 0,
                'authenticated_perms': ['add'],
                'owner_perms': ['view', 'delete'],
            },
        ),
        migrations.AddConstraint(
            model_name='needleusercontactpending',
            constraint=models.UniqueConstraint(fields=('contact_from', 'contact_to_email'), name='unique_contact_to_email'),
        ),
    ]
