# Generated by Django 2.2.28 on 2023-06-04 15:25

from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields
import djangoldp_needle.permissions.booklet_contributor_pending


class Migration(migrations.Migration):

    dependencies = [
        ('djangoldp_needle', '0036_auto_20230526_1301'),
    ]

    operations = [
        migrations.CreateModel(
            name='BookletContributorPending',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('booklet_to_email', models.CharField(max_length=255)),
                ('booklet_from', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='booklet_pending_from', to='djangoldp_needle.Booklet')),
            ],
            options={
                'abstract': False,
                'default_permissions': ['add', 'change', 'delete', 'view', 'control'],
                'rdf_type': 'hd:booklet_contributor_pending',
                'permission_classes': [djangoldp_needle.permissions.booklet_contributor_pending.BookletContributorPendingPermissions],
                'serializer_fields': ['@id', 'creation_date', 'booklet_from', 'booklet_to_email'],
                'depth': 0,
                'authenticated_perms': ['add'],
            },
        ),
        migrations.AddConstraint(
            model_name='bookletcontributorpending',
            constraint=models.UniqueConstraint(fields=('booklet_from', 'booklet_to_email'), name='unique_contributor_pending_contact_to_email'),
        ),
    ]
